#!/usr/bin/env python
# -*- coding: utf-8 -*-
#

"""
Filename: labelling2.py
Date: Jan 12, 2021 - 10:03
Name: Rami MARZOUGUI, Khaled ETTRIKI, Arnaud ROSAY
Description:
    - Labelling flows of CSV files generated by CicFlowMeter
"""

# Folder structure :
# ├─ cicids2017
# │  └─ csv_files
# │     ├─ iscx (used by ts2epoch.py
# │     │  ├─ Monday-WorkingHours.pcap_ISCX.csv
# │     │  ├─ Tuesday-WorkingHours.pcap_ISCX.csv
# │     │  ├─ Wednesday-workingHours.pcap_ISCX.csv
# │     │  ├─ Thursday-WorkingHours-Morning-WebAttacks.pcap_ISCX.csv
# │     │  ├─ Thursday-WorkingHours-Afternoon-Infilteration.pcap_ISCX.csv
# │     │  ├─ Friday-WorkingHours-Morning.pcap_ISCX.csv
# │     │  ├─ Friday-WorkingHours-Afternoon-DDos.pcap_ISCX.csv
# │     │  └─ Friday-WorkingHours-Afternoon-PortScan.pcap_ISCX.csv
# │     ├─ epoch
# │     │  ├─ Monday-WorkingHours.pcap_ISCX_epoch.csv
# │     │  ├─ Tuesday-WorkingHours.pcap_ISCX_epoch.csv
# │     │  ├─ Wednesday-workingHours.pcap_ISCX_epoch.csv
# │     │  ├─ Thursday-WorkingHours-Morning-WebAttacks.pcap_ISCX_epoch.csv
# │     │  ├─ Thursday-WorkingHours-Afternoon-Infilteration.pcap_ISCX_epoch.csv
# │     │  ├─ Friday-WorkingHours-Morning.pcap_ISCX_epoch.csv
# │     │  ├─ Friday-WorkingHours-Afternoon-DDos.pcap_ISCX_epoch.csv
# │     │  └─ Friday-WorkingHours-Afternoon-PortScan.pcap_ISCX_epoch.csv
# │     ├─ cfm
# │     │  ├─ Monday-WorkingHours.pcap_Flow.csv
# │     │  ├─ Monday-WorkingHours.pcap_pktlist.csv
# │     │  ├─ Tuesday-WorkingHours.pcap_Flow.csv
# │     │  ├─ Tuesday-WorkingHours.pcap_pktlist.csv
# │     │  ├─ Wednesday-workingHours.pcap_Flow.csv
# │     │  ├─ Wednesday-workingHours.pcap_pktlist.csv
# │     │  ├─ Thursday-WorkingHours-Morning-WebAttacks.pcap_Flow.csv
# │     │  ├─ Thursday-WorkingHours-Morning-WebAttacks.pcap_pktlist.csv
# │     │  ├─ Thursday-WorkingHours-Afternoon-Infilteration.pcap_Flow.csv
# │     │  ├─ Thursday-WorkingHours-Afternoon-Infilteration.pcap_pktlist.csv
# │     │  ├─ Friday-WorkingHours-Morning.pcap_Flow.csv
# │     │  ├─ Friday-WorkingHours-Morning.pcap_pktlist.csv
# │     │  ├─ Friday-WorkingHours-Afternoon-DDos.pcap_Flow.csv
# │     │  ├─ Friday-WorkingHours-Afternoon-DDos.pcap_pktlist.csv
# │     │  ├─ Friday-WorkingHours-Afternoon-PortScan.pcap_Flow.csv
# │     │  └─ Friday-WorkingHours-Afternoon-PortScan.pcap_pktlist.csv
# │     └─ labelled_flows (created by this program if not existing)
# │     │  ├── Monday-WorkingHours.pcap_Flow_labelled.csv
# │     │  ├── Tuesday-WorkingHours.pcap_Flow_labelled.csv
# │     │  ├── Wednesday-WorkingHours.pcap_Flow_labelled.csv
# │     │  ├── Thursday-WorkingHours.pcap_Flow_labelled.csv
# │     │  └── Friday-WorkingHours.pcap_Flow_labelled.csv
# │     └─ labelled_pkt (for future usage)
# └── python_logs
#     └── labelling_info.log

import pandas as pd
import logging
import os
import glob
import multiprocessing as mp
import time
import numpy as np


# CONSTANTS
LOG_PATH = "./python_logs/"
INPUT_PATH_ISCX = "./cicids2017/csv_files/epoch/"
INPUT_PATH_CFM = "./cicids2017/csv_files/cfm/"
OUTPUT_PATH_LABELLED = "./cicids2017/csv_files/labelled_flows/"
EXT = ".csv"
EPOCH_EXT = "_epoch.csv"

CFM_FILELIST = [
    #"Monday-WorkingHours.pcap_Flow",
    #"Tuesday-WorkingHours.pcap_Flow",
    "Wednesday-WorkingHours.pcap_Flow"
    #"Thursday-WorkingHours.pcap_Flow"
    # "Friday-WorkingHours.pcap_Flow"
]

FEAT_LIST = {
    'flow_id': 0,
    'src_ip': 1,
    'src_port': 2,
    'dst_ip': 3,
    'dst_port': 4,
    'prot': 5,
    'epoch': 6,
    'flow_duration': 7,
    'tot_fwd_pkt': 8,
    'tot_bwd_pkt': 9,
    'fwd_pkt_len_tot': 10,
    'bwd_pkt_len_tot': 11,
    'fwd_pkt_len_max': 12,
    'fwd_pkt_len_min': 13,
    'fwd_pkt_len_mean': 14,
    'fwd_pkt_len_std': 15,
    'bwd_pkt_len_max': 16,
    'bwd_pkt_len_min': 17,
    'bwd_pkt_len_mean': 18,
    'bwd_pkt_len_std': 19,
    'flow_byte_per_s': 20,
    'flow_pkt_per_s': 21,
    'flow_iat_mean': 22,
    'flow_iat_std': 23,
    'flow_iat_max': 24,
    'flow_iat_min': 25,
    'fwd_iat_tot': 26,
    'fwd_iat_mean': 27,
    'fwd_iat_std': 28,
    'fwd_iat_max': 29,
    'fwd_iat_min': 30,
    'bwd_iat_tot': 31,
    'bwd_iat_mean': 32,
    'bwd_iat_std': 33,
    'bwd_iat_max': 34,
    'bwd_iat_min': 35,
    'fwd_psh_flag': 36,
    'bwd_psh_flag': 37,
    'fwd_urg_flag': 38,
    'bwd_urg_flag': 39,
    'fwd_head_len': 40,
    'bwd_head_len': 41,
    'fwd_pkt_per_s': 42,
    'bwd_pkt_per_s': 43,
    'pkt_len_min': 44,
    'pkt_len_mean': 45,
    'pkt_len_std': 46,
    'pkt_len_max': 47,
    'pkt_len_var': 48,
    'fin_flag_cnt': 49,
    'syn_flag_cnt': 50,
    'rst_flag_cnt': 51,
    'psh_flag_cnt': 52,
    'ack_flag_cnt': 53,
    'urg_flag_cnt': 54,
    'cwe_flag_cnt': 55,
    'ece_flag_cnt': 56,
    'down_up_ratio': 57,
    'avg_pkt_size': 58,
    'avg_fwd_segm_size': 59,
    'avg_bwd_segm_size': 60,
    # 'fwd_head_len_bis': 61, ==> not in CFM, then dropped in ISCX
    'avg_fwd_byte_per_bulk': 61,
    'avg_fwd_pkt_per_bulk': 62,
    'avg_fwd_bulk_rate': 63,
    'avg_bwd_byte_per_bulk': 64,
    'avg_bwd_pkt_per_bulk': 65,
    'avg_bwd_bulk_rate': 66,
    'subflow_fwd_pkt': 67,
    'subflow_fwd_byte': 68,
    'subflow_bwd_pkt': 69,
    'subflow_bwd_byte': 70,
    'init_win_bytes_fwd': 71,
    'init_win_bytes_bwd': 72,
    'act_data_pkt_fwd': 73,
    'min_seg_size_forward': 74,
    'active_mean': 75,
    'active_std': 76,
    'active_max': 77,
    'active_min': 78,
    'idle_mean': 79,
    'idle_std': 80,
    'idle_max': 81,
    'idle_min': 82,
    'label': 83
}

Friday_Attacks_IP_List = [
    '192.168.10.12',
    '192.168.10.14',
    '192.168.10.15',
    '192.168.10.17',
    '192.168.10.5',
    '192.168.10.8',
    '192.168.10.9',
    '205.174.165.73',
    '172.16.0.1',
    '192.168.10.50'
]

Tuesday_Wednesday_Attacks_IP_List = [
    '172.16.0.1'
]

Thursday_Attacks_IP_List = [
    '172.16.0.1',
    '192.168.10.8'
]


def initialize_logger(output_dir):
    """
    Initialize logger so that errors are logged in error.log, all messages
    are logged in all.log printed in console

    Parameters
    ----------
    output_dir: str
        String corresponding to the path of the log file

    Returns
    -------
    None
    """
    pyfile = os.path.splitext(os.path.split(__file__)[1])[0]
    # now = datetime.now().strftime("%Y%m%d_%H%M%S")
    # filename = pyfile + "_info_" + now + ".log"
    filename = pyfile + "_info.log"
    logger = logging.getLogger()
    logger.setLevel(logging.DEBUG)
    # create console handler and set level to info
    handler = logging.StreamHandler()
    handler.setLevel(logging.INFO)
    formatter = logging.Formatter("[%(levelname)s] %(asctime)s - "
                                  "%(message)s", datefmt="%Y-%m-%d %H:%M:%S")
    handler.setFormatter(formatter)
    logger.addHandler(handler)
    # create debug file handler and set level to debug
    handler = logging.FileHandler(os.path.join(output_dir, filename), "w")
    handler.setLevel(logging.DEBUG)
    formatter = logging.Formatter("[%(levelname)s] %(asctime)s - "
                                  "%(message)s", datefmt="%Y-%m-%d %H:%M:%S")
    handler.setFormatter(formatter)
    logger.addHandler(handler)


def read_csv(filename):
    """
    load csv file into a DataFrame

    Parameters
    ----------
    filename: str
        file name of the CSV that is loaded

    Returns
    -------
    df: DataFrame
        Pandas DataFrame containing data from CSV
    """
    process_name = mp.current_process().name
    pid = os.getpid()
    template = "{} (PID {}) - Loading CSV {}"
    logging.info(template.format(process_name, pid, filename))
    df = pd.read_csv(filename, encoding="ISO-8859-1", low_memory=False)
    template = "{} (PID {}) - Loaded CSV {}"
    logging.info(template.format(process_name, pid, filename))
    return df


def write_csv(df, filename):
    """
    Write content of DataFrame into a CSV file
    Parameters
    ----------
    df: DataFrame
        DataFrame containing data to be written in CSV
    filename: str
        File name of the CSV to write

    Returns
    -------
    None
    """
    process_name = mp.current_process().name
    pid = os.getpid()
    template = "{} (PID {}) - Writing CSV {}"
    logging.info(template.format(process_name, pid, filename))
    df.to_csv(filename, index=False)
    template = "{} (PID {}) - Written CSV {}"
    logging.info(template.format(process_name, pid, filename))


def merge_multiple_files(day):
    """
    Merge multiple CSV files of the same day and export as CSV.

    Parameters
    ----------
    day : str
        The day for which the CSV files to combine were generated

    Returns
    -------
    None
    """
    process_name = mp.current_process().name
    pid = os.getpid()
    template = "{} (PID {}) - Merging multiple files"
    logging.info(template.format(process_name, pid))
    all_files = glob.glob(os.path.join(INPUT_PATH_ISCX, day + "-*" + EPOCH_EXT))
    df_from_each_file = (pd.read_csv(f, sep=',') for f in all_files)
    df_merged = pd.concat(df_from_each_file, ignore_index=True)
    df_merged.to_csv(day + "-WorkingHours.pcap_ISCX" + EPOCH_EXT)
    template = "{} (PID {}) - Merged {} files together for {}"
    logging.info(template.format(process_name, pid, len(all_files), day))


def sort_by_epoch(df):
    """
    Sort a Pandas DataFrame by the column containing Epoch Time in an
    ascending order.
    The column name is passed as a parameter because it differs depending on
    the source.
    csv file being original or generated.

    Parameters
    ----------
    df: DataFrame
        Pandas DataFrame to be sorted

    Returns
    -------
    df_out: DataFrame
        sorted Pandas DataFrame
    """
    process_name = mp.current_process().name
    pid = os.getpid()
    template = "{} (PID {}) - Sorting by epoch time"
    logging.info(template.format(process_name, pid))
    df_out = df.sort_values(by=['epoch',
                                'src_port', 'dst_port',
                                'src_ip', 'dst_ip'],
                            ascending=[True,
                                       True, True,
                                       True, True],
                            inplace=False)
    df_out.reset_index(drop=True, inplace=True)
    template = "{} (PID {}) - Sorted all lines"
    logging.info(template.format(process_name, pid))
    return df_out


def create_pivot_table(df_sorted):
    """
    Create a pivot table in a Pandas DataFrame containing the timestamp and
    the corresponding first and last index in the sorted DataFrame of the
    original csv file and a label associated to the index range
    If there is not a unique label, label is 'not_unique'

    Parameters
    ----------
    df_sorted: DataFrame
        Sorted Pandas DataFrame used to create the timestamp indexes table

    Returns
    -------
    df_pivot : DataFrame
        Pandas DataFrame containing the timestamp, first_index, last_index and
        label indication (string) about label unicity inside the range
    """
    process_name = mp.current_process().name
    pid = os.getpid()
    template = "{} (PID {}) - Creating timestamp table"
    logging.info(template.format(process_name, pid))
    df_pivot = df_sorted.index.to_series().groupby(df_sorted['epoch']).agg(
        ['first', 'last']).reset_index()
    template = "{} (PID {}) - Timestamp table created"
    logging.info(template.format(process_name, pid))
    template = "i = {} - first = {} - last = {} - label = {}"
    df_pivot['label'] = ''
    for i in range(df_pivot.shape[0]):
        first = df_pivot['first'][i]
        last = df_pivot['last'][i]
        label_series = df_sorted.loc[:][first:last+1]['label'].value_counts()
        if label_series.shape[0] == 1:
            label = df_sorted.loc[:][first:first+1]['label'].iloc[0]
        else:
            label = 'not_unique'
        df_pivot.loc[i, 'label'] = label
        logging.info(template.format(i, first, last, label))
    return df_pivot


def get_infos(timestamp, df_timestamp):
    """
    Return the first and last indexes corresponding to the timestamp in the
    timestamp table.

    Parameters
    ----------
    df_timestamp : DataFrame
        Pandas DataFrame containing the timestamp, first_index and last_index
    timestamp: integer
        An integer that represents the epoch time in seconds

    Returns
    -------
    infos : Tuple
        Tuple containing the first and last indexes and label indication
    """
    process_name = mp.current_process().name
    pid = os.getpid()
    # template = "{} (PID {}) - Get indexes"
    # logging.info(template.format(process_name, pid))
    n_rows = df_timestamp.shape[0]
    infos = (-1, -1, '')
    for i in range(n_rows):
        if timestamp == df_timestamp['epoch'][i]:
            infos = (df_timestamp['first'][i],
                     df_timestamp['last'][i],
                     df_timestamp['label'][i])
            break
    if infos == (-1, -1, ''):
        template = "{} (PID {}) - Timestamp {} not found"
        logging.info(template.format(process_name, pid, timestamp))
    else:
        template = "{} (PID {}) - Got infos: {}"
        logging.info(template.format(process_name, pid, infos))
    return infos


def labelling_func(filename):
    """
    Function that will process the labelling of one file

    Parameters
    ----------
    filename: str
        File name of the generated CSV file to label (written without the extension)

    Returns
    -------
    None
    """
    process_name = mp.current_process().name
    pid = os.getpid()
    template = "{} (PID {}) - Labelling the flows of the generated file"
    logging.info(template.format(process_name, pid))
    df_cfm = read_csv(INPUT_PATH_CFM + filename + EXT)
    if filename == "Monday-WorkingHours.pcap_Flow":
        df_cfm.loc[:, 'Label'] = 'BENIGN'
    else:
        if filename == "Thursday-WorkingHours.pcap_Flow":
            merge_multiple_files("Thursday")
        elif filename == "Friday-WorkingHours.pcap_Flow":
            merge_multiple_files("Friday")
        elif filename == "Wednesday-WorkingHours.pcap_Flow":
            # The ISCX file is called Wednesday-workingHours... while the
            # generated one is called Wednesday-WorkingHours...
            filename = "Wednesday-workingHours.pcap_Flow"
        df_iscx = read_csv(INPUT_PATH_ISCX + filename[:-4] + "ISCX" + EPOCH_EXT)
        # drop duplicated column(fwd header len
        df_iscx = df_iscx.drop(labels=' Fwd Header Length.1', axis=1)
        # create list of column names
        col_names = list(FEAT_LIST.keys())
        df_iscx.columns = col_names
        df_cfm.columns = col_names
        # sort by epoch, src_port, dst_port, src_ip_dst_ip (in this order)
        df_iscx = sort_by_epoch(df_iscx)
        # write sorted ISCX to enable grep in sorted file if not saved yet
        sorted_filename = INPUT_PATH_ISCX + filename[:-4] + 'ISCX_sorted' + EPOCH_EXT
        if not os.path.exists(sorted_filename):
            write_csv(df_iscx, sorted_filename)
        df_cfm = sort_by_epoch(df_cfm)
        df_pivot = create_pivot_table(df_iscx)
        # add empty column 'label'
        df_cfm['label'] = ''
        if filename == "Tuesday-WorkingHours.pcap_Flow" or filename == "Wednesday-workingHours.pcap_Flow":
            attacks_ip_list = Tuesday_Wednesday_Attacks_IP_List
        elif filename == "Thursday-WorkingHours.pcap_Flow":
            attacks_ip_list = Thursday_Attacks_IP_List
        else:  #filename == "Friday-WorkingHours.pcap_Flow"
            attacks_ip_list = Friday_Attacks_IP_List
        n_rows = df_cfm.shape[0]
        period = 10
        template = "{} (PID {}) - Labelled {}/{} - Undetermined {} - Attacks {}"
        n_label_found = 0
        n_label_not_found = 0
        n_attacks = 0
        i = 0
        while i < n_rows:
            # logging.debug("\t{} (PID {}) - i = {}".format(process_name, pid, i))
            current_timestamp = df_cfm['epoch'][i]
            (first_idx, last_idx, lbl_ind) = get_infos(current_timestamp,
                                                       df_pivot)
            if lbl_ind != 'not_unique':
                tmplt = "{} (PID {}) - Unique label {} from {} to {}"
                logging.info(tmplt.format(process_name, pid,
                                          lbl_ind, first_idx, last_idx))
                df_cfm['label'][first_idx:last_idx + 1] = lbl_ind
                n_label_found += last_idx + 1 - first_idx
                i += last_idx + 1 - first_idx
                logging.info(template.format(process_name, pid,
                                             n_label_found, n_rows,
                                             n_label_not_found, n_attacks))  #
            else:
                label = 'Not_found'
                if df_cfm['src_ip'][i] in attacks_ip_list:
                    if first_idx != -1:
                        df_searchable = df_iscx.iloc[first_idx:(last_idx + 1), :].reset_index(drop=True)
                        df_searchable = df_searchable.set_index(
                            ['src_port', 'dst_port', 'src_ip', 'dst_ip', 'prot', 'flow_duration', 'tot_fwd_pkt',
                             'tot_bwd_pkt'])
                        df_new = df_searchable[np.array(df_searchable.index.isin([(df_cfm.loc[i, 'src_port'],
                                                                                   df_cfm.loc[i, 'dst_port'],
                                                                                   df_cfm.loc[i, 'src_ip'],
                                                                                   df_cfm.loc[i, 'dst_ip'],
                                                                                   df_cfm.loc[i, 'prot'],
                                                                                   df_cfm.loc[i, 'flow_duration'],
                                                                                   df_cfm.loc[i, 'tot_fwd_pkt'],
                                                                                   df_cfm.loc[i, 'tot_bwd_pkt'])]),
                                                        dtype=bool)]
                        labels_set = df_new.loc[:]['label'].value_counts()
                        if labels_set.shape[0] == 1:
                            label = labels_set.index[0]
                        else:
                            label = 'Undetermined'
                elif df_cfm['dst_ip'][i] in attacks_ip_list:
                    if first_idx != -1:
                        df_searchable = df_iscx.iloc[first_idx:(last_idx + 1), :].reset_index(drop=True)
                        df_searchable = df_searchable.set_index(
                            ['src_port', 'dst_port', 'src_ip', 'dst_ip', 'prot', 'flow_duration', 'tot_fwd_pkt',
                             'tot_bwd_pkt'])
                        df_new = df_searchable[np.array(df_searchable.index.isin([(df_cfm.loc[i, 'dst_port'],
                                                                                   df_cfm.loc[i, 'src_port'],
                                                                                   df_cfm.loc[i, 'dst_ip'],
                                                                                   df_cfm.loc[i, 'src_ip'],
                                                                                   df_cfm.loc[i, 'prot'],
                                                                                   df_cfm.loc[i, 'flow_duration'],
                                                                                   df_cfm.loc[i, 'tot_fwd_pkt'],
                                                                                   df_cfm.loc[i, 'tot_bwd_pkt'])]),
                                                        dtype=bool)]
                        labels_set = df_new.loc[:]['label'].value_counts()
                        if labels_set.shape[0] == 0:
                            label = 'BENIGN'
                        elif labels_set.shape[0] == 1:
                            label = labels_set.index[0]
                        else:
                            label = 'Undetermined'
                else:
                    label = 'BENIGN'
                # df_cfm['label'][i] = label
                df_cfm.loc[i, 'label'] = label
                if label != 'Undetermined' and label != 'Not_found':
                    # logging.debug("Label: {}".format(label))
                    n_label_found += 1
                    if label != 'BENIGN':
                        n_attacks += 1
                else:
                    # logging.debug("Label: {}".format(label))
                    n_label_not_found += 1
                i += 1
                if i % period == 0:
                    logging.info(template.format(process_name, pid,
                                                 n_label_found, n_rows,
                                                 n_label_not_found, n_attacks))
        template = "{} (PID {}) - Labelling done - Labelled {}/{} - Attacks {}"
        logging.info(template.format(process_name, pid, n_rows, n_rows,
                                     n_attacks))
    # Save the results
    write_csv(df_cfm, OUTPUT_PATH_LABELLED + filename + "_Labelled" + EXT)


def main():
    # create output directories if they don't exist yet
    if not os.path.exists(OUTPUT_PATH_LABELLED):
        os.makedirs(OUTPUT_PATH_LABELLED)
    if not os.path.exists(LOG_PATH):
        os.makedirs(LOG_PATH)
    initialize_logger(LOG_PATH)
    # show # of CPUs and files
    n_cpu = mp.cpu_count()
    n_files = len(CFM_FILELIST)
    template = "Number of CPUs: {} - Number of files: {}"
    logging.info(template.format(n_cpu, n_files))
    time.sleep(1)
    # select number of thread
    n_threads = 0
    max_thread = min(n_cpu, n_files)
    # DEBUG
    # labelling_func(CFM_FILELIST[0])
    # DEBUG
    loop_exit = False
    while not loop_exit:
        template = "Enter # of processing thread (1-{}): ".format(max_thread)
        n_threads = int(input(template))
        if 0 < n_threads <= max_thread:
            loop_exit = True
        else:
            print("!!! Correct values: from {} to {} !!!".format(0,
                                                                 max_thread))
    # process all files using the selected number of threads
    pool = mp.Pool(n_threads)
    pool.map(labelling_func, CFM_FILELIST)
    logging.info("----Program finished----")


if __name__ == '__main__':
    main()
